/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO (Extended = ExtendedPersistenceContext ConversationScope (Group = EntityExtendedDAO.class)
 *
 */

package de.ivu.elect.business.personenpruefung.boundary;

import javax.inject.Inject;

import de.ivu.elect.business.personenpruefung.entity.PersonenKonflikt;
import de.ivu.elect.jee.entity.ExtendedDAO;

@javax.enterprise.context.RequestScoped
public class PersonenKonfliktExtendedDAO extends AbstractPersonenKonfliktDAO implements java.io.Serializable {

  private static final long serialVersionUID = 1L;

  @Inject
  transient ExtendedDAO extendedDAO;

  @Inject
  transient de.ivu.elect.presentation.system.ExtendedDAORequestCache cache;

  @Override
  protected javax.persistence.EntityManager getEntityManager() {
    return extendedDAO.getEntityManager();
  }

  @Override
  public void flush() {
    extendedDAO.flush();
  }

  public void flushNewTransaction() {
    extendedDAO.flushNewTransaction();
  }

/**
* Name: PersonAndKonfliktArtNoFlush<br>
* Beschreibung: <br>
* EJBQL: SELECT k FROM PersonenKonflikt k WHERE k.personendaten = ?1 AND k.personenKonfliktArt IN (?2)<br>
* SQL: <br>
*/
@Override
public java.util.List<PersonenKonflikt> findByPersonAndKonfliktArt( @javax.annotation.Nonnull de.ivu.elect.business.person.entity.Personendaten personendaten,  @javax.annotation.Nonnull java.util.Collection<de.ivu.elect.business.personenpruefung.entity.PersonenKonfliktArt> konfliktArten) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("PersonenKonflikt.findByPersonAndKonfliktArt" ,  personendaten ,  konfliktArten  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByPersonAndKonfliktArt(): Miss");
        }

        cache.put(key, super.findByPersonAndKonfliktArt( personendaten ,  konfliktArten  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByPersonAndKonfliktArt(): Hit");
      }

      return new java.util.ArrayList<>((java.util.List<PersonenKonflikt>) cache.lookup(key));
    }

    return super.findByPersonAndKonfliktArt( personendaten ,  konfliktArten  );
}
/**
* Name: PersonAndKonfliktStatusNoFlush<br>
* Beschreibung: <br>
* EJBQL: SELECT k FROM PersonenKonflikt k WHERE k.personendaten = ?1 AND k.personenKonfliktStatus IN (?2)<br>
* SQL: <br>
*/
@Override
public java.util.List<PersonenKonflikt> findByPersonAndKonfliktStatus( @javax.annotation.Nonnull de.ivu.elect.business.person.entity.Personendaten personendaten,  @javax.annotation.Nonnull java.util.Collection<de.ivu.elect.business.personenpruefung.entity.PersonenKonfliktStatus> konfliktStatus) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("PersonenKonflikt.findByPersonAndKonfliktStatus" ,  personendaten ,  konfliktStatus  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByPersonAndKonfliktStatus(): Miss");
        }

        cache.put(key, super.findByPersonAndKonfliktStatus( personendaten ,  konfliktStatus  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByPersonAndKonfliktStatus(): Hit");
      }

      return new java.util.ArrayList<>((java.util.List<PersonenKonflikt>) cache.lookup(key));
    }

    return super.findByPersonAndKonfliktStatus( personendaten ,  konfliktStatus  );
}

  @Override
  public void clear() {
    cache.clear();

    super.clear();
  }
}
